#include <windows.h>
#include <GdiPlus.h>

#pragma comment(lib,"GdiPlus.lib")

#define MYWNDCLASS		"Gdip01MemoryDeviceContext"
#define MYWNDTITLE		"Gdip01MemoryDeviceContext"

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;
Bitmap				*Bmp_R = NULL;

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Draw_Image(HDC hDC, int width, int height);
void Read_Image(char *fname);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 480, 480,
				NULL,
				NULL,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	width,height;
	
	switch (uMsg)
	{
	case WM_CREATE:
		GdiplusStartup(&gdiToken,&gdiSI,NULL);
		Read_Image("sample.jpg");
		return 0;
	case WM_SIZE:
		width	= LOWORD(lParam);
		height	= HIWORD(lParam);
		return 0;
	case WM_PAINT:
		HDC			hDC;
		PAINTSTRUCT	ps;
		// `揀
		hDC = BeginPaint(hWnd,&ps);
		Draw_Image(hDC, width, height);
		// `I
		EndPaint(hWnd,&ps);
		return 0;
	case WM_CLOSE:
		delete Bmp_R;
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// 摜̕`
void Draw_Image(HDC hDC, int width, int height)
{
	// NCAg̈TCY̍Ɨprbg}bv쐬
	Bitmap bmpCp(width, height, PixelFormat32bppARGB);
	// Ɨprbg}bṽOtBbNIuWFNg쐬
	Graphics gBmp(&bmpCp);
	// Ɨprbg}bṽNbsO
	Rect rcBmp(0, 0, width, height);
	gBmp.SetClip(rcBmp);
	// 摜Ɨprbg}bv֕`
	if(Bmp_R){
		gBmp.DrawImage(Bmp_R, 0, 0, Bmp_R->GetWidth(), Bmp_R->GetHeight());
	}
	// NbsO
	gBmp.ResetClip();
	// foCXReLXg̃OtBbNIuWFNg쐬
	Graphics	g(hDC);
	// Ɨprbg}bvfoCXReLXg֕`
	g.DrawImage(&bmpCp, 0, 0, bmpCp.GetWidth(), bmpCp.GetHeight());
}// Draw_Image

// t@C摜ǂݍ
void Read_Image(char *fname)
{
	WCHAR	wfname[MAX_PATH];
	
	MultiByteToWideChar(CP_ACP,0,fname,-1,wfname,sizeof(wfname));
	delete Bmp_R;
	Bmp_R = Bitmap::FromFile(wfname,FALSE);
}// Read_Image
