#include <windows.h>
#include <GdiPlus.h>

#pragma comment(lib,"GdiPlus.lib")

#define MYWNDCLASS			"Gdip03SavePng"
#define MYWNDTITLE			"Gdip03SavePng"
#define	FREE(p)				{free(p);p=NULL;}
#define	SAFE_DELETE_OBJ(p)	if (p){delete  p;p=NULL;}

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;
Bitmap				*Bmp_R1 = NULL,*Bmp_R2 = NULL,*Bmp_S = NULL;

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Draw_Image(HDC hDC);
Status ChangeFormat_32bppTo24bpp();
void Read_Image(Bitmap **Bmp, char *fname);
void Save_Png(char *sfname);
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 480, 480,
				NULL,
				NULL,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		GdiplusStartup(&gdiToken,&gdiSI,NULL);
		Read_Image(&Bmp_R1, "sample.jpg");
		Read_Image(&Bmp_R2, "sample2.png");
		Bmp_S = new Bitmap(240, 320, PixelFormat32bppARGB);
		return 0;
	case WM_PAINT:
		HDC			hDC;
		PAINTSTRUCT	ps;
		// `揀
		hDC = BeginPaint(hWnd,&ps);
		Draw_Image(hDC);
		// `I
		EndPaint(hWnd,&ps);
		return 0;
	case WM_CLOSE:
		Save_Png("save.png");
		delete Bmp_R1;
		delete Bmp_R2;
		delete Bmp_S;
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// 摜̕`
void Draw_Image(HDC hDC)
{
	// ۑprbg}bṽOtBbNIuWFNg쐬
	Graphics gBmp(Bmp_S);
	// Ɨprbg}bṽNbsO
	Rect rcBmp(0, 0, Bmp_S->GetWidth(), Bmp_S->GetHeight());
	gBmp.SetClip(rcBmp);
	// 摜Ɨprbg}bv֕`
	if(Bmp_R1){
		gBmp.DrawImage(Bmp_R1, 0, 0, Bmp_R1->GetWidth(), Bmp_R1->GetHeight());
	}
	if(Bmp_R2){
		gBmp.DrawImage(Bmp_R2, 50, 50, Bmp_R2->GetWidth(), Bmp_R2->GetHeight());
	}
	// NbsO
	gBmp.ResetClip();
	// foCXReLXg̃OtBbNIuWFNg쐬
	Graphics	g(hDC);
	// Ɨprbg}bvfoCXReLXg֕`
	g.DrawImage(Bmp_S, 0, 0, Bmp_S->GetWidth(), Bmp_S->GetHeight());
}// Draw_Image

// 摜tH[}bgϊ 32bpp24bpp
Status ChangeFormat_32bppTo24bpp()
{
	Status		st = GenericError;
	PixelFormat	pfmt_r = PixelFormat32bppARGB;
	PixelFormat	pfmt_s = PixelFormat24bppRGB;

	if(!Bmp_S){
		return st;
	}
	
	if(Bmp_S->GetPixelFormat() == pfmt_r){
		BitmapData	bitmapData;
		int			wdh	= Bmp_S->GetWidth();
		int			hgt	= Bmp_S->GetHeight();
		Rect		rect(0, 0, wdh, hgt);
		BYTE		*pxl_buf = NULL;
		// flǂݍ
		st = Bmp_S->LockBits(&rect, ImageLockModeRead, pfmt_r, &bitmapData);
		if (st == Ok)
		{
			BYTE	*pxl1 = NULL;	// flǂݍރ|C^
			// fl̐擪AhX pxl1 ɑ 
			if (bitmapData.Stride > 0)
				pxl1 = (BYTE*) bitmapData.Scan0;
			else
				pxl1 = (BYTE*) bitmapData.Scan0
						+ (bitmapData.Stride)*(bitmapData.Height-1);
			// pxl_buf ̃m
			pxl_buf = (LPBYTE) malloc (wdh*hgt*4);
			// fl pxl1  pxl_buf ɃRs[
			memcpy(pxl_buf, pxl1, wdh*hgt*4);
			// bitmapData.Scan0 ̃
			st = Bmp_S->UnlockBits(&bitmapData);
		}
		SAFE_DELETE_OBJ(Bmp_S);
		Bmp_S = new Bitmap(wdh, hgt, pfmt_s);
		// fl
		st = Bmp_S->LockBits(&rect, ImageLockModeWrite, pfmt_s, &bitmapData);
		if (st == Ok)
		{
			BYTE	*pxl1 = NULL;
			UINT	stride1;
			int		x,y,rest,ct1 = 0,ct2 = 0;
			if (bitmapData.Stride > 0)
				pxl1 = (BYTE*) bitmapData.Scan0;
			else
				pxl1 = (BYTE*) bitmapData.Scan0
						+ (bitmapData.Stride)*(bitmapData.Height-1);
			// 4byteE
			stride1 = abs(bitmapData.Stride);
			// 4byteEŗ]f
			rest = stride1 - wdh * (24 / 8);
			// AlphalȊỎfl pxl1 փRs[
			if(pxl_buf){
				for(y=0;y<hgt;y++){
					for(x=0;x<wdh;x++){
						pxl1[ct1++] = pxl_buf[ct2++];	// Blue
						pxl1[ct1++] = pxl_buf[ct2++];	// Green
						pxl1[ct1++] = pxl_buf[ct2++];	// Red
						pxl_buf[ct2++];					// Alpha
					}
					// 4byteEŗ]f0Ŗ߂
					for(x=0;x<rest;x++){
						pxl1[ct1++] = 0;
					}
				}
			}
			st = Bmp_S->UnlockBits(&bitmapData);
		}
		FREE(pxl_buf);
	}
	return st;
}// ChangeFormat_32bppTo24bpp

// t@C摜ǂݍ
void Read_Image(Bitmap **Bmp, char *fname)
{
	WCHAR	wfname[MAX_PATH];
	
	MultiByteToWideChar(CP_ACP,0,fname,-1,wfname,sizeof(wfname));
	delete *Bmp;
	*Bmp = Bitmap::FromFile(wfname,FALSE);
}// Read_Image

// 摜PNGt@Cɕۑ
void Save_Png(char *sfname)
{
	Status				st;
	CLSID				clsid;
	EncoderParameters	ecps;
	ULONG				bpp = 24;	// F[xi1,4,8,24,32j
	WCHAR				wsfname[MAX_PATH];
	
	if(!Bmp_S){
		return;
	}
	// 摜tH[}bgϊ 32bpp24bpp
	st = ChangeFormat_32bppTo24bpp();
	// PNGCLSID擾
	GetEncoderClsid(L"image/png", &clsid);
	// t@CjR[hɕϊ
	MultiByteToWideChar(CP_ACP, 0, sfname, -1, wsfname, sizeof(wsfname));
	// PNGF[xݒ
	ecps.Count = 1;
	ecps.Parameter[0].Guid = EncoderColorDepth;
	ecps.Parameter[0].Type = EncoderParameterValueTypeLong;
	ecps.Parameter[0].NumberOfValues = 1;
	ecps.Parameter[0].Value = &bpp;
	// 摜t@Cɕۑ
	st = Bmp_S->Save(wsfname, &clsid, &ecps);
	if(st == Ok){
		MessageBox(GetFocus(), "摜ۑ܂", MYWNDTITLE, MB_OK);
	}
}// Save_Png

// MIMECLSID擾
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
	UINT num  = 0; // number of image encoders
	UINT size = 0; // size of the image encoder array in bytes
	
	ImageCodecInfo* pImageCodecInfo = NULL;
	
	GetImageEncodersSize(&num, &size);
	if(size == 0)
		return -1; // Failure
	
	pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
	if(pImageCodecInfo == NULL)
		return -1; // Failure
	
	GetImageEncoders(num, size, pImageCodecInfo);
	
	for(UINT j = 0; j < num; ++j)
	{
		if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
		{
			*pClsid = pImageCodecInfo[j].Clsid;
			FREE(pImageCodecInfo);
			return j; // Success
		}
	}
	
	FREE(pImageCodecInfo);
	return -1; // Failure
}// GetEncoderClsid
