#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <GdiPlus.h>

#pragma comment(lib,"GdiPlus.lib")

#define MYWNDCLASS		"Gdip04GetProperty"
#define MYWNDTITLE		"Gdip04GetProperty"

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;
Bitmap				*Bmp_R = NULL;			// rbg}bvIuWFNg
PropertyItem		*gpPropBuffer = NULL;	// rbg}bv
UINT				gnumProperties = 0; 	// rbg}bv̍ڐ

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
Status Get_Property();
void Read_Image(char *fname);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 480, 480,
				NULL,
				NULL,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	width,height;
	
	switch (uMsg)
	{
	case WM_CREATE: // 
		GdiplusStartup(&gdiToken, &gdiSI, NULL);
		Read_Image("sample.jpg");
		return 0;
	case WM_PAINT:	// `
		HDC 		hDC;
		PAINTSTRUCT ps;
		hDC = BeginPaint(hWnd, &ps);
		if(gpPropBuffer){
			UINT	i;
			char	strValue[256],strBuf[512];
			// vpeB̕\
			_itoa(gnumProperties ,strValue, 10);
			_snprintf(strBuf, sizeof(strBuf)-1, "ڐ %s", strValue);
			TextOut(hDC, 0, 0, strBuf, strlen(strBuf));
			// ږ̕\
			_snprintf(strBuf, sizeof(strBuf)-1, "ID    TYPE  l", strValue);
			TextOut(hDC, 0, 18, strBuf, strlen(strBuf));
			// vpeBl̕\
			for(i=0; i<gnumProperties; i++){
				switch (gpPropBuffer[i].type)
				{
				case PropertyTagTypeASCII:
					strncpy(strValue, (char*) gpPropBuffer[i].value, sizeof(strValue)-1);
					break;
				case PropertyTagTypeRational:
					{
						DWORD* value = (DWORD*)(gpPropBuffer[i].value);
						if(gpPropBuffer[i].length == 24){
							_snprintf(strValue, sizeof(strValue)-1, "%d/%d/%d/%d", value[0], value[1], value[2], value[3]);
						}
						else{
							_snprintf(strValue, sizeof(strValue)-1, "%d/%d", value[0], value[1]);
						}
					}
					break;
				default:
					{
						BYTE* value = (BYTE*) gpPropBuffer[i].value;
						_snprintf(strValue, sizeof(strValue)-1, "%d", value[0]);
					}
					break;
				}
				_snprintf(strBuf, sizeof(strBuf)-1, "0x%04x %d % 6u %s", gpPropBuffer[i].id, gpPropBuffer[i].type, gpPropBuffer[i].length, strValue);
				TextOut(hDC, 0, (i+2)*18, strBuf, strlen(strBuf));
			}
		}
		// `I
		EndPaint(hWnd, &ps);
		return 0;
	case WM_CLOSE:	// I
		free(gpPropBuffer);
		delete Bmp_R;
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// 摜̃vpeB擾
Status Get_Property()
{
	Status	st = GenericError;
	UINT	totalBufferSize;
	
	if(!Bmp_R){
		return st;
	}
	
	st = Bmp_R->GetPropertySize(&totalBufferSize, &gnumProperties);
	if(st == Ok){
		gpPropBuffer = (PropertyItem*) malloc(totalBufferSize);
		st = Bmp_R->GetAllPropertyItems(totalBufferSize, gnumProperties, gpPropBuffer);
	}
	return st;
}// Get_Property

// t@C摜ǂݍ
void Read_Image(char *fname)
{
	WCHAR	wfname[MAX_PATH];
	
	MultiByteToWideChar(CP_ACP,0,fname,-1,wfname,sizeof(wfname));
	delete Bmp_R;
	Bmp_R = Bitmap::FromFile(wfname,FALSE);
	Get_Property();
}// Read_Image
