#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <GdiPlus.h>

#pragma comment(lib,"GdiPlus.lib")

#define MYWNDCLASS		"Gdip05DrawLine"
#define MYWNDTITLE		"Gdip05DrawLine"

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Draw_Image(HDC hDC, int width, int height);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 480, 480,
				NULL,
				NULL,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	width,height;
	
	switch (uMsg)
	{
	case WM_CREATE:
		GdiplusStartup(&gdiToken,&gdiSI,NULL);
		return 0;
	case WM_SIZE:
		width	= LOWORD(lParam);
		height	= HIWORD(lParam);
		return 0;
	case WM_PAINT:
		HDC			hDC;
		PAINTSTRUCT	ps;
		// `揀
		hDC = BeginPaint(hWnd,&ps);
		Draw_Image(hDC, width, height);
		// `I
		EndPaint(hWnd,&ps);
		return 0;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// 摜̕`
void Draw_Image(HDC hDC, int width, int height)
{
	// NCAg̈TCY̍Ɨprbg}bv쐬
	Bitmap bmpCp(width, height, PixelFormat32bppARGB);
	// Ɨprbg}bṽOtBbNIuWFNg쐬
	Graphics gBmp(&bmpCp);
	// Ɨprbg}bṽNbsO
	Rect rcBmp(0, 0, width, height);
	gBmp.SetClip(rcBmp);
	// Ɨprbg}bv֒`
	Pen pen1(Color::Blue, 8);
	gBmp.DrawLine(&pen1, 20, 30, 200, 30);
	// CLbvꍇ
	pen1.SetStartCap((LineCap)(LineCapNoAnchor + 2));
	pen1.SetEndCap((LineCap)(LineCapNoAnchor + 1));
	gBmp.DrawLine(&pen1, 20, 60, 200, 60);
	// ꍇ
	AdjustableArrowCap acap(4.0f, 3.0f);
	acap.SetMiddleInset(1.0f);
	pen1.SetCustomEndCap(&acap);
	gBmp.DrawLine(&pen1, 20, 90, 200, 90);
	// ̐ݒ
	pen1.SetDashStyle((DashStyle)(DashStyleSolid + 1));
	gBmp.DrawLine(&pen1, 20, 120, 200, 120);
	// ̃CLbvꍇ
	pen1.SetDashCap((DashCap)(DashCapFlat + 2));
	gBmp.DrawLine(&pen1, 20, 150, 200, 150);
	// X[WO
	gBmp.SetSmoothingMode(SmoothingModeAntiAlias);
	gBmp.DrawLine(&pen1, 20, 180, 200, 180);
	// ܂̏ꍇ
	Point pt1[] = {Point(20, 210), Point(200, 210), Point(200, 300)};
	Pen pen2(Color::Coral, 12);
	gBmp.DrawLines(&pen2, pt1, 3);
	// ̋Ȃp̐ݒ
	Point pt2[] = {Point(20, 240), Point(150, 240), Point(150, 300)};
	pen2.SetLineJoin((LineJoin)(LineJoinMiter + 2));
	gBmp.DrawLines(&pen2, pt2, 3);
	// Ȑ̏ꍇ
	Point pt3[] = {Point(20, 270), Point(100, 270), Point(100, 300)};
	gBmp.DrawCurve(&pen2, pt3, 3);
	// nb`uV̏ꍇ
	HatchBrush brush1((HatchStyle) 35, Color::Green, Color::LightSkyBlue);
	pen2.SetWidth(20);
	pen2.SetBrush(&brush1);
	gBmp.DrawLine(&pen2, 20, 330, 200, 330);
	// NbsO
	gBmp.ResetClip();
	// foCXReLXg̃OtBbNIuWFNg쐬
	Graphics	g(hDC);
	// Ɨprbg}bvfoCXReLXg֕`
	g.DrawImage(&bmpCp, 0, 0, bmpCp.GetWidth(), bmpCp.GetHeight());
}// Draw_Image
