#include <windows.h>
#include <GdiPlus.h>

#pragma comment(lib,"GdiPlus.lib")

#define MYWNDCLASS		"Gdip06Path"
#define MYWNDTITLE		"Gdip06Path"

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;
GraphicsPath		*Path1 = NULL;
GraphicsPath		*Path2 = NULL;

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Draw_Image(HDC hDC, int width, int height);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 480, 480,
				NULL,
				NULL,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	width,height;
	
	switch (uMsg)
	{
	case WM_CREATE:
		GdiplusStartup(&gdiToken,&gdiSI,NULL);
		// pXIuWFNg̍쐬
		Path1 = new GraphicsPath();
		Path2 = new GraphicsPath();
		return 0;
	case WM_SIZE:
		width	= LOWORD(lParam);
		height	= HIWORD(lParam);
		return 0;
	case WM_PAINT:
		HDC			hDC;
		PAINTSTRUCT	ps;
		// `揀
		hDC = BeginPaint(hWnd,&ps);
		// 摜̕`
		Draw_Image(hDC, width, height);
		// `I
		EndPaint(hWnd,&ps);
		return 0;
	case WM_CLOSE:
		delete Path1;
		delete Path2;
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// 摜̕`
void Draw_Image(HDC hDC, int width, int height)
{
	// NCAg̈TCY̍Ɨprbg}bv쐬
	Bitmap bmpCp(width, height, PixelFormat32bppARGB);
	// Ɨprbg}bṽOtBbNIuWFNg쐬
	Graphics gBmp(&bmpCp);
	// Ɨprbg}bṽNbsO
	Rect rcBmp(0, 0, width, height);
	gBmp.SetClip(rcBmp);
	// pXP̍쐬ƕ`
	if(Path1){
		// pXP̍쐬Jn
		Path1->StartFigure();
		// pXPɃ|Cgǉ
		Point pt1[] = {Point(20, 10), Point(200, 10), Point(200, 150)};
		Path1->AddPolygon(pt1, 3);
		// pXPɑȉ~ǉ
		Path1->AddEllipse(30, 60, 150, 100);
		// pXP
		Path1->CloseFigure();
		// hԂ[h̐ݒ
		Path1->SetFillMode((FillMode) 1);	// 0 or 1
		// pXPFœhԂ
		SolidBrush brush1(Color(255,255,255,0));
		gBmp.FillPath(&brush1, Path1);
		// pXP̗֊sFŕ`
		Pen pen1(Color::Blue, 1);
		gBmp.DrawPath(&pen1, Path1);
		// pXP̃oEfBO{bNX擾
		Rect bounds;
		Path1->GetBounds(&bounds);
		// oEfBO{bNXԐFŕ`
		Pen pen2(Color::Red, 1);
		gBmp.DrawRectangle(&pen2, bounds);
	}
	// pXQ̍쐬ƕύXƕ`
	if(Path2){
		// pXQ̍쐬Jn
		Path2->StartFigure();
		// pXQɃ|Cgǉ
		Point pt1[] = {Point(220, 10), Point(400, 10), Point(400, 150)};
		Path2->AddPolygon(pt1, 3);
		// pXQ
		Path2->CloseFigure();
		// pXf[^̎擾
		PathData path_data;
		Path2->GetPathData(&path_data);
		// pX̍ŏ̃|CgύX
		path_data.Points[0] = PointF(220, 150);
		// pXQVpXf[^ō蒼
		delete Path2;
		Path2 = new GraphicsPath(path_data.Points, path_data.Types, path_data.Count);
		// pXQ𐅐FœhԂ
		SolidBrush brush1(Color(255,0,255,255));
		gBmp.FillPath(&brush1, Path2);
		// pXQ̗֊sFŕ`
		Pen pen1(Color::Blue, 1);
		gBmp.DrawPath(&pen1, Path2);
	}
	// NbsO
	gBmp.ResetClip();
	// foCXReLXg̃OtBbNIuWFNg쐬
	Graphics	g(hDC);
	// Ɨprbg}bvfoCXReLXg֕`
	g.DrawImage(&bmpCp, 0, 0, bmpCp.GetWidth(), bmpCp.GetHeight());
}// Draw_Image
